unit unit1;

// converted from delphi with KOL Converter 1.0
// minor bugs fixed: through replacing the original VCL 7 code some replacing
// routines replaced themselves ;)
// Editboxes look a lot nicer if edit1.color := clWindow;
//

{
KOL Converter 1.1
Author : retnyg (visit retnygs realm @ http://www.krazz.net/retnyg )

This Program converts your Standard Delphi Tools to KOL-Projects, which compile
to a much better size and are a lot faster.
Currently this is just for Single-Form Programs, but with some additional handwork
it should be no problem to use also with more complex programs.
At least, it should save u a lot of time adapting.
the templates are based on "KOL Project Expert v2.03" (C) Thaddy (www.thaddy.com)

All routines used here are (C) retnyg's brain
  (except AdjustWinControlColor by Thaddy's ;).
You can use an adapt them if you keep my name somewhere inside the code.

}
interface
uses
  Windows, Messages, Kol, shellapi, sysutils;
const
   dpr = 'program Project1;'+#13#10#13#10+'uses'+#13#10+'  Kol,'+#13#10+'  Unit1 in ''Unit1.pas'';'+#13#10#13#10+'begin'+#13#10+'  NewForm1( Form1, nil);'+#13#10+'  Run(Form1.form);'+#13#10+'end.';
   unitheader = 'unit unit1;'+#13#10#13#10+'// converted from delphi VCL with KOL Converter 1.13 (c)2005 by ::retnyg::'+#13#10+'// AdjustControlcolor routine by thaddy'#13#10#13#10+
   '// GUIDE: KOLConv converts your existing form-data to a hardcoded KOL Obj that is created by this code'#13#10 +
   '// just load the resulting dpr in delphi and press F9, you will probably get some errors that result from small differences in kol'#13#10+
   '// if the compiler whines on unknown properties, just try to comment it out, if you not need that property really.'#13#10+
   '// if you need it, you should look in kol.pas for corresponding properties.'#13#10+
   '// some adaptments you have to make yourself, ie: memo1.lines.add(someStr); gets to memo1.add(someStr+#13#10), as the lines property is not supported by KOL'#13#10+
   '// so also memo1.lines.count goes to memo1.count, and memo1.lines[i] gets to memo1.items[i]. usually, you have to adapt like 5 lines of code by hand.'#13#10+
   '// if you declared variables in the definition of your VCL form, you have to copy these to the new source file, as they currently dont get parsed (F9 will tell you which variables are missing)'#13#10#13#10+
   '// further documentation can be found on http://krazz.net/retnyg/kolconv.htm'#13#10#13#10 +'interface'+#13#10+'uses'+#13#10+'  Windows, Messages, Kol, VCLAliases;'+#13#10;
   unittypedef = 'type'+#13#10#13#10;
   unittypeform = 'PForm1=^TForm1;'+#13#10+'TForm1=object(Tobj)'+#13#10+'  Form:pControl;'+#13#10+'private'+#13#10;
   unitpt1 = 'public'+#13#10+'   // Add your eventhandlers here, example:'+#13#10+'  function DoMessage(var Msg:Tmsg;var Rslt:integer):boolean;'+#13#10;
   unitpt2 = 'end;'+#13#10#13#10+'procedure NewForm1( var Result: PForm1; AParent: PControl );'+#13#10#13#10+'var'+#13#10+'  Form1:pForm1;'+#13#10;
   unitvarblk = #13#10+'implementation'+#13#10#13#10+
                 'procedure AdjustWinControlColor(aParent:PControl;const aColor:TColor = clWindow);'#13#10+'var'#13#10+'  i:integer;'#13#10+'begin'#13#10+'  with aParent^ do'#13#10+'    if Boolean(Childcount) then'#13#10+'      for i:= 0 to pred(Childcount) do'#13#10+'      begin'#13#10+'      if (AnsiComparetext(Children[i].subclassname,''obj_EDIT'') = 0)  or'#13#10+'         (AnsiComparetext(Children[i].subclassname,''obj_COMBOBOX'') = 0) or'#13#10+'         (AnsiComparetext(Children[i].subclassname,''obj_LISTBOX'') = 0) then'#13#10+'         Children[i].Color:=aColor;'#13#10+'         If Children[i].childcount > 0 then'#13#10+'         AdjustWinControlColor(Children[i]);'#13#10+'      end;'#13#10+'end;'#13#10#13#10+
                 'procedure NewForm1( var Result: PForm1; AParent: PControl );'+#13#10+'begin'+#13#10+'  New(Result,Create);'+#13#10+'  with Result^ do'+#13#10+'  begin'+#13#10+'    Form:= NewForm(AParent,''KOLForm'').SetSize(600,400).centeronparent.Tabulate;'+#13#10+'    Applet:=Form;'+#13#10+'    Form.OnMessage:=DoMessage;'+#13#10+'    Form.Add2AutoFree(Result);'+#13#10;
   unitpt3 = 'AdjustWinControlColor(applet, clWindow);'#13#10+'  end;'+#13#10+'end;'+#13#10#13#10+'function TForm1.DoMessage(var Msg:TMsg;var Rslt:integer):Boolean;'+#13#10+'begin'+#13#10+'  Result:=false;'+#13#10+'end;'+#13#10;
   unitpt4 = #13#10+'end.'+#13#10;

   vclalias = 'unit VCLAliases;'#13#10'(*'#13#10'This unit contains aliases for functions and procedures with the'#13 +
#10'same functionality but with different names in KOL and the Delphi VCL/RTL.'#13 + 
#10'This way I do not have to translate all calls in the code itself.'#13 +
#10'This technique adds very little - 4 bytes per function - code, does'#13 + 
#10 +
'*not* introduce extra indirection and can save you a lot of time if you are'#13 + 
#10'translating VCL sources to KOL. The advantage over search and replace is that'#13 + 
#10'you can keep the sources more compatible between KOL and VCL versions.'#13 + 
#10#13#10'Please do not include anything in the implementation section,'#13 + 
#10'this unit is for straight aliases only. I am working on a unit for procedures'#13 + 
#10'and functions with the same functionality but different syntax, like some of'#13 + 
#10 + 
'the DateTime and string functions.'#13 + 
#10#13#10'Please add anything similar you know of or find here.'#13 + 
#10'Please send modified versions to me first.'#13 + 
#10#13#10'V 0.001'#13#10'Work in progress,'#13 + 
#10'Februari 2004,'#13 + 
#10'Thaddy de Koning'#13#10'*)'#13#10#13#10'interface'#13 + 
#10#13#10'uses'#13#10'windows,kol;'#13#10 + 
#13#10'type'#13#10'TMakerect = function ( Left, Top, Right, Bottom: Integer ): TRect; stdcall;'#13 + 
#10'TMakePoint = function ( X, Y: Integer ): TPoint;'#13 + 
#10'TInt2Str = function ( Value : Integer ) : String;'#13 + 
#10'TInt2Hex = function ( Value : DWord; Digits : Integer ) : String;'#13 + 
#10'TStr2Int = function (const Value : String) : Integer;'#13 + 
#10#13#10'const'#13#10'Rect :TMakeRect = Makerect;'#13 + 
#10'Point :TMakePoint = MakePoint;'#13 + 
#10'IntToStr:TInt2Str = Int2Str;'#13 + 
#10'IntToHex:TInt2Hex = Int2Hex;'#13 + 
#10'StrToInt:TStr2Int = Str2Int;'#13 + 
#10#13#10'implementation'#13 + 
#10'// leave empty please!, only for pure aliases'#13 + 
#10'end.'#13#10;

type

  objekt = record
     name: string;
     typ: string;
     parent: string;
     properties:string;
  end;

PForm1=^TForm1;
TForm1=object(Tobj)
  Form:pControl;
private
   Label1 : PControl;
   Label2 : PControl;
   Label3 : PControl;
   Edit1 : PControl;
   Edit2 : PControl;
   Edit3 : PControl;
   Button1 : PControl;
   button2: PControl;
   OpenDialog1: TOpenSaveDialog;
public
   // Add your eventhandlers here, example:
  function DoMessage(var Msg:Tmsg;var Rslt:integer):boolean;
    procedure FormShow(Sender: PObj);
    procedure Button1Click(Sender: PObj);
    procedure Button2Click(Sender: PObj);
    procedure FormDestroy(Sender: PObj);
end;

procedure NewForm1( var Result: PForm1; AParent: PControl );

var
  Form1:pForm1;
  objekte: array of objekt;
  objektcount: integer = 0;


implementation
{$R *.res}
procedure NewForm1( var Result: PForm1; AParent: PControl );
begin
  New(Result,Create);
  with Result^ do
  begin
    Form:= NewForm(AParent,'KOLForm').SetSize(600,400).centeronparent.Tabulate;
    Applet:=Form;
    Form.OnMessage:=DoMessage;
    Form.Add2AutoFree(Result);
   Form.Left := 198;
   Form.Top := 110;
   Form.Width := 328;
   Form.Height := 167;
   Form.Caption := 'VCL 2 KOL Converter 1.13    by ::retnyg::';
   Form.Color := clBtnFace;
   Form.Font.Color := clWindowText;
   Form.OnDestroy := FormDestroy;
   Form.OnShow := FormShow;

//Form1.Font.Fontheight := 6; // KOL uses bigger fonts than vcl
Label1 := NewLabel(Form,''); //enhancement may be required here
   Label1.Left := 8;
   Label1.Top := 8;
   Label1.Width := 52;
   Label1.Height := 13;
   Label1.Caption := 'Delphi Unit';

   Label1.Font.Fontheight := 6; // KOL uses bigger fonts than vcl
Label2 := NewLabel(Form,''); //enhancement may be required here
   Label2.Left := 8;
   Label2.Top := 32;
   Label2.Width := 56;
   Label2.Height := 13;
   Label2.Caption := 'Delphi Form';

   Label2.Font.Fontheight := 6; // KOL uses bigger fonts than vcl
Label3 := NewLabel(Form,''); //enhancement may be required here
   Label3.Left := 8;
   Label3.Top := 72;
   Label3.Width := 64;
   Label3.Height := 13;
   Label3.Caption := 'Output Folder';

   Label3.Font.Fontheight := 6; // KOL uses bigger fonts than vcl
Edit1 := NewEditBox(Form,[]); //enhancement may be required here
   Edit1.Left := 88;
   Edit1.Top := 8;
   Edit1.Width := 210;
   Edit1.Height := 21;
   Edit1.TabOrder := 0;
   Edit1.Text := 'Edit1';
   edit1.Color := clWindow;
   Edit1.Font.Fontheight := 6; // KOL uses bigger fonts than vcl
Edit2 := NewEditBox(Form,[]); //enhancement may be required here
   Edit2.Left := 88;
   Edit2.Top := 32;
   Edit2.Width := 210;
   Edit2.Height := 21;
   Edit2.TabOrder := 1;
   Edit2.Text := 'Edit2';
   edit2.Color := clWindow;
   Edit2.Font.Fontheight := 6; // KOL uses bigger fonts than vcl
Edit3 := NewEditBox(Form,[]); //enhancement may be required here
   Edit3.Left := 88;
   Edit3.Top := 72;
   Edit3.Width := 210;
   Edit3.Height := 21;
   Edit3.TabOrder := 2;
   Edit3.Text := 'Edit3';
   edit3.Color := clWindow;
   Edit3.Font.Fontheight := 6; // KOL uses bigger fonts than vcl
Button1 := NewButton(Form,''); //enhancement may be required here
   Button1.Left := 104;
   Button1.Top := 104;
   Button1.Width := 75;
   Button1.Height := 25;
   Button1.Caption := 'Convert';
   Button1.TabOrder := 3;
   Button1.OnClick := Button1Click;

Button2 := NewButton(Form,'...'); //enhancement may be required here
   Button2.Left := edit1.left+edit1.width+3;
   Button2.Top := edit1.top;
   Button2.Width := 16;
   Button2.Height := edit1.height;
   Button2.TabOrder := 2;
   Button2.OnClick := Button2Click;



//Button1.Font.Fontheight := 6; // KOL uses bigger fonts than vcl
  end;
end;

function TForm1.DoMessage(var Msg:TMsg;var Rslt:integer):Boolean;
begin
  Result:=false;
end;


function string2file(filename, aString: string; appendmode:boolean):boolean;
var f: textfile;//file of char;
    i : integer;
begin
   assignfile(f,filename);
   if appendmode then append(f) else rewrite(f);
   for i := 1 to length(aString) do
     write(f,astring[i]);
   closefile(f);
   result := true;
end;

function file2string(filename:string;txtfile:boolean):string;
var f: file of char;
    f2: textfile;
    s:string;
    c:char;
begin
   result := '';
   if fileexists(filename) then
   begin
     if txtfile then
     begin
       S:='';
       assignfile(f2,filename);
       reset(f2);
       while not eof(f2) do
       begin
          readln(f2,s);
          result := result + s;
       end;
       closefile(f2);
     end
     else
     begin
       assignfile(f,filename);
       reset(f);
       while not eof(f) do
       begin
         read (f,c);
         result := result + c;
       end;
       closefile(f);
     end;
   end;
end;

function strreplace(s,what, whit:string):string;
begin
   result := stringreplace(s,what,whit,[rfReplaceAll]);
end;

function strreplace_2(s,what, whit:string):string;
// difference: replaces term independant of capital letters, but leaves the rest
// in original state.
var lastfound,fpos: integer;
begin
   lastfound := 0;
   result := s;
   while pos(uppercase(what), uppercase(copy(result,lastfound+1,length(result)))) > 0 do
   begin
     lastfound := lastfound + pos(uppercase(what), uppercase(copy(result,lastfound+1,length(result))));
//     result := copy(result,1,pos(what, result)-1) + whit + copy(result,pos(what, result) + length(what),length(result));
     result := copy(result,1,lastfound-1) + whit + copy(result,lastfound + length(what),length(result));
     lastfound := lastfound - (length(what)-length(whit));
    // s := copy(result,lastfound+1,length(result));
   end;
end;

procedure TForm1.FormShow(Sender: PObj);
var s : string;
begin
  if not fileexists(extractfilepath(paramstr(0))+'kolconv.txt') then
  begin
    edit1.Text := extractfilepath(paramstr(0)) + 'unitx.pas';
    edit2.Text := extractfilepath(paramstr(0)) + 'unitx.dfm';
    edit3.Text := extractfilepath(paramstr(0)) + 'KOLProj\';
  end
  else
  begin
    s:=file2string(extractfilepath(paramstr(0))+'kolconv.txt',false);
    edit1.text := copy(s,1,pos(#13#10,s)-1); s:=copy(s,pos(#13#10,s)+2,length(s));
    edit2.text := copy(s,1,pos(#13#10,s)-1); s:=copy(s,pos(#13#10,s)+2,length(s));
    edit3.text := copy(s,1,pos(#13#10,s)-1); s:=copy(s,pos(#13#10,s)+2,length(s));
  end;
end;

function isobsolete(s:string):boolean;
begin
    result := false;
    if pos('Font.Charset',s) > 0 then result := true else
    if pos('Font.Height',s) > 0 then result := true else
    if pos('Font.Name',s) > 0 then result := true else
    if pos('Font.Style',s) > 0 then result := true else
    if pos('OldCreateOrder',s) > 0 then result := true else
    if pos('PixelsPerInch',s) > 0 then result := true else
    if pos('TextHeight',s) > 0 then result := true else
    if pos('Icon.Data',s) > 0 then result := true else
    if pos('ScrollBars',s) > 0 then result := true else
    if pos('Default ',s) > 0 then result := true else
    if pos('Alignment ',s) > 0 then result := true else
    if pos('ParentFont ',s) > 0 then result := true else
    if pos('WordWrap ',s) > 0 then result := true;
end;


function getformobjects:string;
var s,s2,lastparent, ctrltag: string;
    started, newsubobj, getnextprop : boolean;
    subobj: byte;
    i:integer;
begin
    s:=file2string(form1.edit2.text,false);
    started := falsE;
    newsubobj := true;
    getnextprop := false;
    result := '';
    subobj := 0;
    while s <> '' do
    begin
       s2 := '';
       s2 := copy (s,1,pos(#$A,s));
       s := copy(s,length(s2)+1,length(s));
       if getnextprop then begin
         while pos('}',s2) = 0 do begin
           s2 := copy (s,1,pos(#$A,s));
           s := copy(s,length(s2)+1,length(s));
         end;
         s2 := copy (s,1,pos(#$A,s));
         s := copy(s,length(s2)+1,length(s));
         getnextprop := false;
       end;
       if (pos ('OBJECT'#$20,uppercase(s2)) > 0)  then
       begin
         inc(subobj);inc(objektcount);
         if (objektcount >= 2) and (newsubobj) then lastparent := Objekte[objektcount-2].name;
         newsubobj := true;
         setlength(objekte,objektcount);
         objekte[objektcount-1].name := copy(s2, pos('OBJECT ',uppercase(s2))+7,pos(':',s2)-7-pos('OBJECT ',uppercase(s2)));
         objekte[objektcount-1].typ := strreplace(copy(s2, pos(':',s2)+1,length(s2)),#13#10,'');

         case subobj of 1: objekte[objektcount-1].parent := 'AParent';
                        2: objekte[objektcount-1].parent := 'Form';
         else
           objekte[objektcount-1].parent := lastparent;
         end;
         objekte[objektcount-1].properties := '';
       end
       else
       begin
          if pos('END'#$D,uppercase(s2)) > 0 then
          begin
            dec(subobj);
            NewSubObj:=false;
          end
          else
          begin
             s2 := strreplace(s2,'=',':=');
             s2 := strreplace(s2,#13#10,';')+#13#10;
             if objektcount = 1 then
             begin
//                if (isobsolete(s2)) and (pos('{',s2) > 0) then getnextprop := true;
               if not isobsolete(s2) then
                 objekte[objektcount-1].properties := objekte[objektcount-1].properties + '   Form.' + trim(s2) + #13#10
               else if pos('{',s2) > 0 then getnextprop := true;
             end
             else
             begin
               if pos('=',s2) = 0 then
                 objekte[objektcount-1].properties := copy(objekte[objektcount-1].properties,1,length(objekte[objektcount-1].properties)-3) + trim(s2) + #13#10
               else begin
                 if isobsolete(s2) then s2 := '// ' + objekte[objektcount-1].name + '.' + trim(s2)
                 else s2 := objekte[objektcount-1].name + '.' + trim(s2);
                 objekte[objektcount-1].properties := objekte[objektcount-1].properties + '   ' + s2 + #13#10
               end;
             end;
          end;
       end;
    end;
    result := '';
    for i := 1 to objektcount-1 do
    begin
      if uppercase(trim(objekte[i].typ)) = 'TTIMER' then ctrltag := 'PTimer'
        else ctrltag := 'PControl';
      result := result + '   ' + objekte[i].name + ' : ' + ctrltag + ';'#13#10;
    end;
end;



function getcustomconstblock:string;
var s,s2: string;
    started : boolean;
begin
    s:=file2string(form1.edit1.text,false);
    started := falsE;
    result := '';
    while s <> '' do
    begin
       s2 := '';
       s2 := copy (s,1,pos(#$A,s));
       s := copy(s,length(s2)+1,length(s));
       if (pos ('TYPE'#$D, uppercase(s2)) > 0) or
          (pos ('TYPE'#$20, uppercase(s2)) > 0) then exit;
       if (pos ('IMPLEMENTATION'#$D,uppercase(s2)) > 0) or
          (pos ('IMPLEMENTATION'#$20,uppercase(s2)) > 0) then exit;
       if (pos ('CONST'#$D,uppercase(s2)) > 0) or
          (pos ('CONST'#$20,uppercase(s2)) > 0) then started := true;
       if started then result := result + s2;
    end;
end;

function getFormprocedures:string;
var s,s2: string;
    started : boolean;
begin
    s:=file2string(form1.edit1.text,false);
    started := falsE;
    result := '';
    while s <> '' do
    begin
       s2 := '';
       s2 := copy (s,1,pos(#$A,s));
       s := copy(s,length(s2)+1,length(s));
       if (pos ('(TFORM)',uppercase(s2)) > 0)  then
        started := true;
       if started then
       (if (pos ('END;'#$D,uppercase(s2)) > 0) or (pos ('END;'#$20,uppercase(s2)) > 0) then
        exit
       else
        (if (pos('FUNCTION'#$20,uppercase(s2)) > 0) or (pos('PROCEDURE'#$20,uppercase(s2)) > 0) then
          result := result + strreplace(s2,'TObject','PObj')))
    end;
end;

function getGlobalVariables:string;
var s,s2: string;
    started,trigger2,trigger3 : boolean;
begin
    s:=file2string(form1.edit1.text,false);
    started := falsE; trigger2:=false;
    result := '';
    while s <> '' do
    begin
       s2 := '';
       s2 := copy (s,1,pos(#$A,s));
       s := copy(s,length(s2)+1,length(s));
       if (pos ('(TFORM)',uppercase(s2)) > 0)  then
        started := true;
       if (started) and (trigger2) and (trigger3) then
       (if (pos ('IMPLEMENTATION',uppercase(s2)) > 0)  then
         exit
       else
        (if (pos(objekte[0].name,s2) < 1)  then
          result := result + s2));

       if started and not trigger2 then
         if (pos ('END;'#$D,uppercase(s2)) > 0) or (pos ('END;'#$20,uppercase(s2)) > 0) then
           trigger2 := true;
       if (started) and (trigger2) and (not trigger3) then
         if (pos ('VAR'#$D,uppercase(s2)) > 0) or (pos ('VAR'#$20,uppercase(s2)) > 0) then
           trigger3 := true;

    end;
end;


function getcustomtypes:string;
var s,s2: string;
    started : boolean;
begin
    s:=file2string(form1.edit1.text,false);
    started := falsE;
    result := '';
    while s <> '' do
    begin
       s2 := '';
       s2 := copy (s,1,pos(#$A,s));
       s := copy(s,length(s2)+1,length(s));
       if (pos ('IMPLEMENTATION'#$D,uppercase(s2)) > 0) or (pos ('IMPLEMENTATION'#$20,uppercase(s2)) > 0) then exit;

       if started then
       (if (pos ('(TFORM)', uppercase(s2)) > 0) then
        started := false
       else
        result := result + s2);
       if (pos ('TYPE'#$D,uppercase(s2)) > 0) or (pos ('TYPE'#$20,uppercase(s2)) > 0) then
        started := true;

    end;

end;

function lookupNewOptions(typ,aparent:string):string;
var options,comment,utyp: string;
begin
   comment := '//enhancement may be required here';
   typ := trim(typ);
   typ := copy(typ,2,length(typ));
   utyp := uppercase(typ);
   if utyp = 'EDIT' then
   begin
      typ := 'EditBox';
      options :=aparent+',[]';
      comment := '';
   end else
   if utyp = 'LABEL' then
   begin
      options :=aparent+','#$27#$27;
      comment := '';
   end else
   if utyp = 'BUTTON' then
   begin
      options :=aparent+','#$27#$27;
      comment := '';
   end else
   if utyp = 'CHECKBOX' then
   begin
      options :=aparent+','#$27#$27;
      comment := '';
   end else
   if utyp = 'GROUPBOX' then
   begin
      options :=aparent+','#$27#$27;
      comment := '';
   end else
   if utyp = 'MEMO' then
   begin
      typ := 'EditBox';
      options :=aparent+',[eoMultiLine]';
      comment := '';
   end else
   if utyp = 'RADIOBUTTON' then
   begin
      typ := 'RadioBox';
      options :=aparent+','#$27#$27;
   end else
   if utyp = 'OPENDIALOG' then
   begin
      typ := 'OpenSaveDialog';
      options :='''title'',''C:\'',[TOpenSaveOptions]';
      comment := '// CTRL-click TOpenSaveoptions to see available options, define Opendialog1.OpenDialog := true if its a opendialog, and false if its a savedialog';
   end else
   if utyp = 'SAVEDIALOG' then
   begin
      typ := 'OpenSaveDialog';
      options :='''title'',''C:\'',[TOpenSaveOptions]';
      comment := '// CTRL-click TOpenSaveoptions to see available options, define Opendialog1.OpenDialog := true if its a opendialog, and false if its a savedialog';
   end;
   result := 'New' + typ + '('+ options + '); '+comment+#13#10;
end;

function getFormObjectsProperties:string;
var i : integer;
begin
   result:='';
   for i := 0 to objektcount - 1 do
   begin
      if i <> 0 then result := result + objekte[i].name + ' := ' + lookupnewoptions(objekte[i].typ,objekte[i].parent)
      else result := '    Form.font.releasehandle;'#13#10'    Form.font.assignhandle(getstockobject(DEFAULT_GUI_FONT));'#13#10;
      result := result + objekte[i].properties + #13#10; //+'//   ' + objekte[i].name + '.Font.Fontheight := 6; // KOL uses bigger fonts than vcl'#13#10;
   end;
end;

function GetRoutines:string;
var s,s2: string;
    started : boolean;
begin
    s:=file2string(form1.edit1.text,false);
    started := falsE;
    result := '';
    while s <> '' do
    begin
       s2 := '';
       s2 := copy (s,1,pos(#$A,s));
       s := copy(s,length(s2)+1,length(s));
       if started then
       (if (pos ('END.'#$D, uppercase(s2)) > 0) or (pos ('END.'#$20, uppercase(s2)) > 0) AND (length(s2) < 8)  then
        exit
       else
        if pos('*.DFM}',uppercase(s2)) < 1 then
        result := result + strreplace(s2,'TObject','PObj'));
       if (pos ('IMPLEMENTATION'#$D,uppercase(s2)) > 0) or (pos ('IMPLEMENTATION'#$20,uppercase(s2)) > 0) then
        started := true;

    end;

end;

procedure TForm1.Button2Click(Sender: PObj);
begin
    opendialog1.OpenDialog := true;
    opendialog1.Filter := '*.pas|*.pas';
    opendialog1.InitialDir := extractfilepath(copy(edit3.text,1,length(edit3.text)-2));
    if opendialog1.Execute then begin
      edit1.text := opendialog1.filename;
      edit2.text := copy(edit1.text,1,pos('.',edit1.text))+'dfm';
      edit3.Text := extractfilepath(edit1.text) + 'KOLProj\';
    end;
end;

procedure TForm1.Button1Click(Sender: PObj);
CONST CSWarning = 'The target folder exists already and contains files'#13#10'that will be overwritten.'#13#10#13#10'Are you sure you want to continue ?';
var
    path,s,prj_file,unit_file : string;
begin
   path := edit3.text;
   prj_file := path + 'project1.dpr';
   unit_file := path + 'unit1.pas';
   if not directoryexists(path) then
     forcedirectories(path)
   else
     if (fileexists (prj_file)) or (fileexists (unit_file)) then begin
       if MessageBox(form.handle,CSWarning,'Warning', MB_YESNO or MB_ICONWARNING ) = ID_NO then exit;
     end;

   string2file(prj_file,dpr,false);
   string2file(unit_file,unitheader,false);
   s :=getcustomconstblock;
   string2file(unit_file,s,true); s:= '';

   string2file(unit_file,unittypedef,true);
   s:=getcustomtypes;
   string2file(unit_file,s,true); s:= '';

   string2file(unit_file,unittypeform,true);
   s:=  getformobjects;
   string2file(unit_file,s,true); s:= '';

   string2file(unit_file,unitpt1,true);
   s:= getFormprocedures;
   string2file(unit_file,s,true); s:= '';
   //getotherpublicvariables;

   string2file(unit_file,unitpt2,true);
   s:= getGlobalVariables;
   string2file(unit_file,s,true); s:= '';

   string2file(unit_file,unitvarblk,true);
   s:= getFormObjectsProperties;
   string2file(unit_file,s,true); s:= '';

   string2file(unit_file,unitpt3,true);
   s:= GetRoutines;
   string2file(unit_file,s,true); s:= '';

   string2file(unit_file,unitpt4,true);

   s:=file2string(unit_file,false);
{   s:=strreplace(s,'inttostr','int2str');
   s:=strreplace(s,'strtoint','str2int');
   s:=strreplace(s,'inttohex','int2hex'); }
   s:=strreplace_2(s,'Application.exename','paramstr(0)');
   string2file(unit_file,s,false); s:= '';
   string2file(path + 'VCLAliases.pas',vclalias,false);
   showmessage('done.');
   ShellExecute(form.Handle, 'open', pchar(path), nil, nil, SW_SHOW);
end;

procedure TForm1.FormDestroy(Sender: PObj);
begin
  string2file(extractfilepath(paramstr(0))+'kolconv.txt',edit1.Text +#13#10+edit2.text+#13#10+edit3.Text+#13#10,false);
end;


end.
